#ifdef __OpenBSD__
#include <sys/param.h>
#include <sys/sysctl.h>
#endif /* __OpenBSD__ */

#include "module.h"

#define AUTHOR "Rob"
#define VERSION "1.1"

#ifdef __OpenBSD__
#undef AUTHOR
#define AUTHOR "joris"
#endif

int my_do_sysuptime(User *u);
void Module_Help_sysuptime(User *u);
int Module_Help_sys_full(User *u);
char *my_sysuptime(void);

int AnopeInit(int argc, char **argv) {
	Command *c;
	c=createCommand("sysuptime",my_do_sysuptime,is_services_admin,-1,-1,-1,-1,-1);
	alog("os_sysuptime: New Command /msg operserv sysuptime - Status: %d",moduleAddCommand(OPERSERV,c,MOD_HEAD));
	moduleSetOperHelp(Module_Help_sysuptime);
	moduleAddHelp(c,Module_Help_sys_full);
	moduleAddAuthor(AUTHOR);
	moduleAddVersion(VERSION);
	return MOD_CONT;
}

int Module_Help_sys_full(User *u)
{
       if (is_services_admin(u)) {
       		notice(s_OperServ,u->nick, "------------------------------------------------------------");
       		notice(s_OperServ,u->nick, " Syntaxe : /msg LeNa SYSUPTIME");
       		notice(s_OperServ,u->nick, "   ");
       		notice(s_OperServ,u->nick, " Cette commande sert  voir l'uptime du shell.");
       		notice(s_OperServ,u->nick, "  ");
      		notice(s_OperServ,u->nick, "------------------------------------------------------------");
       		return MOD_STOP;
       }
       return MOD_STOP;
}

void Module_Help_sysuptime(User *u)
{
   if (is_services_admin(u)) {
       notice(s_OperServ,u->nick, "    SYSUPTIME    Permet de voir l'uptime du Shell");
   }
   return;
}

int my_do_sysuptime(User *u) {
	char *time=NULL;
	if(u) {
		time = my_sysuptime();
		if(time) {
			notice(s_OperServ,u->nick,"Shell Uptime: [%s]",time);
			free(time);
		} else {
			notice(s_OperServ,u->nick,"Module unable to get system uptime");
		}
	}
	return MOD_CONT;
}

char *my_sysuptime(void) {
	FILE *fp;
	int seconds;
	int days = 0, hours = 0, minutes = 0;
	char tmp[40],*ptr;
#ifdef __OpenBSD__ 
	int mib[2];
	size_t size;
	time_t now;
	struct timeval boottime;

	mib[0] = CTL_KERN;
	mib[1] = KERN_BOOTTIME;
	size = sizeof(boottime);
	if (sysctl(mib, 2, &boottime, &size, NULL, 0) < 0)
		return (NULL);
	time(&now);
	seconds = now - boottime.tv_sec;
	seconds += 30;
#else	
	fp = fopen("/proc/uptime","r");
	if( fp == NULL ) {
		return NULL;
	}
	fscanf(fp,"%d",&seconds);
	fclose(fp);
#endif /* __OpenBSD__ */
	days = seconds / 86400;
	seconds -= (days * 86400);
	hours = seconds / 3600;
	seconds -= (hours * 3600);
	minutes = seconds / 60;

	sprintf(tmp,"\2%d\2 jours \2%d\2 heures \2%d\2 minutes",days,hours,minutes);
	ptr = (char *)calloc(strlen(tmp)+1,sizeof(char));
	if( ptr != NULL) {
		strcpy(ptr,tmp);
	} else {
		return NULL;
	}
	return ptr;
}



